/* Hamsterkontrolle */
#include "hamster.h"

#include "MyHamster.h"
#include "control.h"

#include "MyData.h"


void hms_ctrl (HAMSTER *hms) {
  Control c;                                                                    /* initialisieren */
  MyHamster mh;


  
  mh.hamster = hms;
  mh.list = *init_List(out_MyData);
  c.myhamster = &mh;
  c.position = begin(&mh.list);                                                 /* initialisieren ende */

  append_s(&c);                                                                 /* Startfeld in Liste */
  c.position = begin(&c.myhamster->list);                                       /* Zeiger auf Sartfeld */
  look(scan_start, &c);                                                         /* Startfeld erforschen */


  while (((struct MyData *)begin(&c.myhamster->list).item->node)->dir!=none) {  /* bis vom Start keine Ausgaenge mehr abzuarbeiten sind */

    while (((struct MyData *)c.position.item->node)->godir!=none) {             /* bis Ende einer "Sackgasse"  erreicht */
      append_f(&c);                                                             /* neues Feld in Liste */
      go(go_next, &c);                                                          /* neues Feld betreten */
      look(scan, &c);                                                           /* neues Feld erforschen */
      if (((struct MyData *)c.position.item->node)->godir == none) {            /* am Ende einer Sackgasse */
	while (((struct MyData *)c.position.item->node)->godir == none && ((struct MyData *)c.position.item->node)->fromdir != none) {
	                                                                        /* Solange am Ende der Liste / Sackgasse und es noch weiter zurueck geht  */
	  if (((struct MyData *)c.position.item->node)->corn == 0) {            /* wenn kein Korn auf Feld, loeschen, Feld wird nicht mehr betreten */
	    erase_f(&c);
	  }
	  else {                                                                /* andernfalls, Korn da, Feld leerraeumen */
	    while (((struct MyData *)c.position.item->node)->corn != 0) {       /* solange Korn auf dem Feld, Korn nehmen */
	      take(&c);
	      while (((struct MyData *)c.position.item->node)->corn == 0 && ((struct MyData *)c.position.item->node)->godir == none && ((struct MyData *)c.position.item->node)->fromdir != none) {                                	   /* wenn das letzte Feld leer ist und es sich nicht um das Startfeld handelt */
		erase_f(&c);                                                    /* letztes Feld loeschen */
	      }
	      go(go_start, &c);                                                 /* wenn Feld nicht leer, zurueck zum Start, Korn ablegen */
	      go(go_end, &c);                                                   /* zum letzten Feld zurueck */
	    }
	  }
	}
      }
    }
  }
  erase_s(&c);                                                                  /* Liste loeschen */
}
/* alles leergesucht */


/* Die Strategie des Hamsters */
/*
  Der Algorithmus versucht Sackgassen im Labyrinth zu finden und leerzuraeumen, dabei spielt es keine Rolle, ob es Sackgassen im eigentlichen Sinne gibt (ein Ausgang, durch
  Waende begrenzt). Als Begrenzung fuer die Sackgasse werden auch Felder angesehen, die schon einmal betreten wurden. Dadurch wird die Bildung von Kreisen vermieden und
  es koennen auch "freie Flaechen" also mehrere zusammenhaenkende Felder, die keine Sackgasse im eigentlichen Sinne bilden, abgearbeitet werden.
  Wenn der Hamster die Moeglichkeit hat, von einem Feld aus mehrere Felder zu betreten, merkt er sich die Richtungen zwecks spaeterer Abarbeitung und geht erst einmal in
  eine Richtung weiter. Das Feld, auf das er geht, wird in die Liste aufgenommen.
  Erreicht der Hamster das Ende einer Sackgasse, so faengt er an, sie vom Ende her leerzuraeumen und die gefundenen Koerner zum Start zu bringen. Ist das Feld leer, wird 
  es aus der Liste geloescht. Wird beim Abbauen der Liste ein Feld erreicht, wo ein Abzweig ist und der Abzweig noch nicht besucht wurde, wird die Liste in diese Richtung
  wieder aufgebaut und eine neue Sackgasse gesucht. Dies wird solange wiederholt, bis das Labyrinth leer ist.

  Der Algorithmus ist nicht sehr effizient, wenn in dem Labyrinth viele Kreise und freie Flaechen vorkommen, da Kreise vermieden werden und dadurch moegliche kuerzere Wege
  nicht gegeangen werden.
  

 */
